% K   workspace
clear;
clc;

% M ,           
flag=1;  
kindex=1;
N=0;
fid=fopen('ritz.txt','a');

%        -     f,p  q.
while flag
f = '2*pi^2*sin(pi*x)';
q = 'pi^2';
p = '1';

%          [4]
N=N+10;			
X = zeros(1,N+2);H = zeros(1,N+1);
Q = zeros(6,N+1);A = zeros(1,N+1);
B = zeros(1,N+1);C = zeros(1,N+1);
a_temp = zeros(1,N+1);b_matrix = zeros(1,N+1); 
zeta = zeros(1,N+1);
z = zeros(1,N+1);
X(1) = 0;
X(N+2) = 1;

% O        
step = 1/(N+1);
for J = 1 : N
    X(J+1) = J*step;
    H(J) = step;
end;
H(N+1) = step; 
N1 = N-1;

% Y   Q       
%    a_temp  b_temp     
%  simpson
 for J = 2 : N
     Q(1,J-1) = simpson (1,X(J),X(J+1),q,f,p)/((H(J))*(H(J)));
     Q(2,J-1) = simpson (2,X(J-1),X(J),q,f,p)/((H(J-1))*(H(J-1)));
     Q(3,J-1) = simpson (3,X(J),X(J+1),q,f,p)/((H(J))*(H(J)));
     Q(4,J-1) = simpson (4,X(J-1),X(J),q,f,p)/((H(J-1))*(H(J-1)));
     Q(5,J-1) = simpson (5,X(J-1),X(J),q,f,p)/  H(J-1) ;
     Q(6,J-1) = simpson (6,X(J),X(J+1),q,f,p)/  H(J)   ;
 end
     Q(2,N)   = simpson (2,X(N),X(N+1),q,f,p)/((H(N))*(H(N)));
     Q(3,N)   = simpson (3,X(N+1),X(N+2),q,f,p)/((H(N+1))*(H(N+1)));
     Q(4,N)   = simpson (4,X(N),X(N+1),q,f,p)/((H(N))*(H(N)));
     Q(4,N+1) = simpson (4,X(N+1),X(N+2),q,f,p)/((H(N+1))*(H(N+1)));
     Q(5,N)   = simpson (5,X(N),X(N+1),q,f,p)/H(N)
     Q(6,N)    = simpson (6,X(N+1),X(N+2),q,f,p)/H(N+1);

% Y        a_temp  b_temp   
%    [4]
 for J = 2 : N1 + 1
    a_temp (J-1) = Q(4,J-1)+Q(4,J)+Q(2,J-1)+Q(3,J-1);
     b_temp (J-1) = Q(1,J-1)-Q(4,J);
     B(J-1) = Q(5,J-1)+Q(6,J-1);
 end

     a_temp (N) = Q(4,N)+Q(4,N+1)+Q(2,N)+Q(3,N);
     B(N) = Q(5,N)+Q(6,N);

     A(1) = a_temp(1);
     zeta (1) = b_temp (1)/ a_temp(1);
     Z(1) = B(1)/A(1);

 for J = 2 : N1
     A(J) = a_temp (J)- b_temp(J-1)* zeta (J-1);
     zeta (J) = b_temp(J)/A(J);
     Z(J) = (B(J)- b_temp (J-1)*Z(J-1))/A(J);
 end

     A(N) = a_temp(N) - b_temp (N-1) * zeta (N-1);
     Z(N) = (B(N)- b_temp(N-1)*Z(N-1))/A(N);

 % Y   C            
 %   
 C(N) = Z(N);
 for J = 1 : N1
     J1 = N - J;	
     C(J1) = Z(J1)- zeta(J1)*C(J1+1);
 end
 
 %        
 fem_values=C(1:length(C)-1);
 real_values=sin(pi*X);
 real_values=real_values(2:length(real_values)-1);
 
 %    
 err=abs(fem_values-real_values);
 
 %    
 for i=1:length(fem_values)
     err_perc(i)=err(i)/real_values(i);
 end
 err_perc=err_perc*100;
 
 %         
 if norm(err,inf)<=0.00000000001
     flag=0;
 end

 %             
 %            
 disp('  = ');
 N
 disp('    = ');
 norm(err,inf)
 disp('    = ');
 norm(err_perc,inf)
 
 %   Ritz.txt         4 fprintf
 fprintf(fid,'\n------------------------------------------------------------\n');
 fprintf(fid,'%4s %3d\n','N = ',N);
 fprintf(fid,'--------------------------------------------------------------\n');
 fprintf(fid,'%-12s %-12s %-12s %-12s %- 11s\n','X','','E','A ',' ');
 for j = 1 : N
     fprintf(fid,'%11.10f ',X(j));
     fprintf(fid,'%11.10f ',real_values(j));
     fprintf(fid,'%11.10f ',fem_values(j));
     fprintf(fid,'%11.10f ',err(j));
     fprintf(fid,'  %20.19f',err_perc(j));
     fprintf(fid,'\n');
 end
 fprintf(fid,'\n%-15s %-11.10f','    =  ',norm(err,inf));
 fprintf(fid,'\n%-15s %-11.10f','    =  ',norm(err_perc,inf));
 fprintf(fid,'\n------------------------------------------------------------\n');
 
 %   keep          
 %       (       
 %    txt
 keep(kindex,1)=N;
 keep(kindex,2)=norm(err,inf);
 keep(kindex,3)=norm(err_perc,inf);
 kindex=kindex+1;

end

%     
fclose(fid);
